<html>
<head>
<title>OgreGLES2FrameBufferObject.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_03408e7e26591a021d5048c9e4238005.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLES2FrameBufferObject.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLES2FrameBufferObject_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OgreGLES2FBO_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OgreGLES2FBO_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2RenderTexture_8h.html">OgreGLES2RenderTexture.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2Context_8h.html">OgreGLES2Context.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035     
<a name="l00036"></a>00036     <span class="keyword">class </span>GLES2FBOManager;
<a name="l00037"></a>00037     <span class="keyword">struct </span>GLES2SurfaceDesc;
<a name="l00038"></a>00038 
<a name="l00041"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html">00041</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html" title="Frame Buffer Object abstraction.">GLES2FrameBufferObject</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043     <span class="keyword">public</span>:
<a name="l00044"></a>00044         <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html" title="Frame Buffer Object abstraction.">GLES2FrameBufferObject</a>(<a class="code" href="classOgre_1_1GLES2FBOManager.html" title="Factory for GL ES 2 Frame Buffer Objects, and related things.">GLES2FBOManager</a> *manager, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00045"></a>00045         ~<a class="code" href="classOgre_1_1GLES2FrameBufferObject.html" title="Frame Buffer Object abstraction.">GLES2FrameBufferObject</a>();
<a name="l00046"></a>00046 
<a name="l00050"></a>00050         <span class="keywordtype">void</span> bindSurface(<span class="keywordtype">size_t</span> attachment, <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLES2SurfaceDesc.html" title="GL surface descriptor.">GLES2SurfaceDesc</a> &amp;target);
<a name="l00053"></a>00053         <span class="keywordtype">void</span> unbindSurface(<span class="keywordtype">size_t</span> attachment);
<a name="l00054"></a>00054         
<a name="l00057"></a>00057         <span class="keywordtype">void</span> bind();
<a name="l00058"></a>00058 
<a name="l00061"></a>00061         <span class="keywordtype">void</span> swapBuffers();
<a name="l00062"></a>00062 
<a name="l00068"></a>00068         <span class="keywordtype">void</span> attachDepthBuffer( <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a> *depthBuffer );
<a name="l00069"></a>00069         <span class="keywordtype">void</span> detachDepthBuffer();
<a name="l00070"></a>00070 
<a name="l00072"></a>00072         <span class="keywordtype">size_t</span> getWidth();
<a name="l00073"></a>00073         <span class="keywordtype">size_t</span> getHeight();
<a name="l00074"></a>00074         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getFormat();
<a name="l00075"></a>00075         GLsizei getFSAA();
<a name="l00076"></a>00076         
<a name="l00077"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a56462a1f99de6bb087688bff3f848170">00077</a>         <a class="code" href="classOgre_1_1GLES2FBOManager.html" title="Factory for GL ES 2 Frame Buffer Objects, and related things.">GLES2FBOManager</a> *<a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a56462a1f99de6bb087688bff3f848170">getManager</a>() { <span class="keywordflow">return</span> mManager; }
<a name="l00078"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a4b05dd41047ea1a2026642e2024d3a42">00078</a>         <span class="keyword">const</span> <a class="code" href="structOgre_1_1GLES2SurfaceDesc.html" title="GL surface descriptor.">GLES2SurfaceDesc</a> &amp;<a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a4b05dd41047ea1a2026642e2024d3a42">getSurface</a>(<span class="keywordtype">size_t</span> attachment) { <span class="keywordflow">return</span> mColour[attachment]; }
<a name="l00079"></a>00079     <span class="keyword">private</span>:
<a name="l00080"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a9e4afd58c7bfe39055e1914ed28eb207">00080</a>         <a class="code" href="classOgre_1_1GLES2FBOManager.html" title="Factory for GL ES 2 Frame Buffer Objects, and related things.">GLES2FBOManager</a> *<a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a9e4afd58c7bfe39055e1914ed28eb207">mManager</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a79525344a0b976a59b7216f54d0ace1b">00081</a>         GLsizei <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a79525344a0b976a59b7216f54d0ace1b">mNumSamples</a>;
<a name="l00082"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a9af67dd8003f8ee805cb85007b8f1568">00082</a>         GLuint <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a9af67dd8003f8ee805cb85007b8f1568">mFB</a>;
<a name="l00083"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a15a62cd652e720a80e0f9c1285b76f7b">00083</a>         GLuint <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a15a62cd652e720a80e0f9c1285b76f7b">mMultisampleFB</a>;
<a name="l00084"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#aa1a24d5873492576b1d4155c67f0c5fc">00084</a>         <a class="code" href="structOgre_1_1GLES2SurfaceDesc.html" title="GL surface descriptor.">GLES2SurfaceDesc</a> <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#aa1a24d5873492576b1d4155c67f0c5fc">mMultisampleColourBuffer</a>;
<a name="l00085"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#ac0313b760b095e807b3aba9eb4dd7f96">00085</a>         <a class="code" href="structOgre_1_1GLES2SurfaceDesc.html" title="GL surface descriptor.">GLES2SurfaceDesc</a> <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#ac0313b760b095e807b3aba9eb4dd7f96">mDepth</a>;
<a name="l00086"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#acf0e5622a17aa755339223688af914e1">00086</a>         <a class="code" href="structOgre_1_1GLES2SurfaceDesc.html" title="GL surface descriptor.">GLES2SurfaceDesc</a> <a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#acf0e5622a17aa755339223688af914e1">mStencil</a>;
<a name="l00087"></a>00087         <span class="comment">// Arbitrary number of texture surfaces</span>
<a name="l00088"></a><a class="code" href="classOgre_1_1GLES2FrameBufferObject.html#a81a808134efbf8f3c254247a3f8790d6">00088</a>         <a class="code" href="structOgre_1_1GLES2SurfaceDesc.html" title="GL surface descriptor.">GLES2SurfaceDesc</a> mColour[<a class="code" href="OgreConfig_8h.html#a1555343fe7aade0966aa442f2e0c16f5" title="Define max number of multiple render targets (MRTs) to render to at once.">OGRE_MAX_MULTIPLE_RENDER_TARGETS</a>];
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00098"></a>00098         <span class="keywordtype">void</span> initialise();
<a name="l00099"></a>00099     };
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
